<template>
  <div style="min-height: 90vh">
    <GToolbar
      :i18n="i18n"
      add-btn-hint="dcc.measurementResults.measurementResultType.add"
      @addElement="addMeasurementResult"
    />
    <div v-if="value.measurementResult.length > 0">
      <GI18nCard
        v-for="(measurementResult, index) in value.measurementResult"
        :key="index"
        ref="measurementResult"
        class="mt-4"
        optional
        wiki-entry="measurementResult"
        @deleteElement="deleteMeasurementResult(measurementResult)"
      >
        <template #card-title>
          {{ $t("dcc.measurementResults.measurementResultType.title") }}
          {{ index + 1 }}
        </template>
        <template #card-title-append>
          <v-spacer />
          <GDropDownMenu
            i18n="form.addElement"
            :available-elements="availableElements(measurementResult)"
            icon="add"
            :btn-class="level === 'third' ? 'theme--light' : 'theme--dark'"
            @addElement="addElement($event, measurementResult)"
          />
        </template>
        <v-row dense>
          <GCol cols="12">
            <div class="mt-4">
              <DccLocalizedTextBlock
                v-model="measurementResult.name"
                i18n="dcc.measurementResults.measurementResultType.name"
                validate="required"
              />
            </div>
          </GCol>
          <GCol cols="12">
            <GTextField
              v-model="measurementResult._attr.refId"
              i18n="dcc.common.attributes.refId"
              attr-ref-type
            />
          </GCol>
        </v-row>

        <UsedMethodList
          v-if="measurementResult.usedMethods"
          ref="element"
          v-model="measurementResult.usedMethods"
          level="second"
          class="mt-4"
          optional
          @delete="deleteUsedMethods(index)"
        />

        <MeasuringEquipmentList
          v-if="measurementResult.measuringEquipments"
          ref="element"
          v-model="measurementResult.measuringEquipments"
          level="second"
          class="mt-4"
          optional
          @delete="deleteMeasuringEquipments(index)"
        />

        <SoftwareList
          v-if="measurementResult.usedSoftware"
          ref="element"
          v-model="measurementResult.usedSoftware"
          level="second"
          class="mt-4"
          optional
          @delete="deleteUsedSoftware(index)"
        />

        <InfluenceConditionList
          v-if="measurementResult.influenceConditions"
          ref="element"
          v-model="measurementResult.influenceConditions"
          level="second"
          class="mt-4"
          optional
          @delete="deleteInfluenceConditions(index)"
        />

        <DccResults
          v-model="measurementResult.results"
          level="second"
          class="mt-4"
        />
        <StatementList
          v-if="measurementResult.measurementMetaData"
          ref="element"
          v-model="measurementResult.measurementMetaData"
          i18n-base="dcc.common.measurementMetaDataListType"
          class="mt-4"
          level="second"
          optional
          item-key="metaData"
          @delete="deleteMeasurementMetaData(index)"
        />
      </GI18nCard>
    </div>
    <v-alert v-else color="warning" icon="warning" class="mt-4">
      {{ $t("dcc.measurementResults.empty") }}
    </v-alert>
  </div>
</template>

<script>
import {
  MeasurementResultType,
  UsedMethodListType,
  SoftwareListType,
  InfluenceConditionListType,
  MeasuringEquipmentListType,
  MeasurementMetaDataListType,
} from "@d-ptb/dcc-js";
import { validatableMixin } from "../Mixins/validatableMixin";
import GI18nCard from "../App/Common/GI18nCard";
import UsedMethodList from "./Common/UsedMethodList";
import InfluenceConditionList from "./MeasurementResults/InfluenceConditionList";
import DccResults from "./MeasurementResults/DccResults";
import { insertIf, removeFromArray } from "~/assets/util/general";
import SoftwareList from "~/components/DCC/Common/SoftwareList";
import StatementList from "~/components/DCC/Common/StatementList";
import MeasuringEquipmentList from "~/components/DCC/MeasurementResults/MeasuringEquipmentList";
import DccLocalizedTextBlock from "~/components/App/Form/XML/DccLocalizedTextBlock";
import GTextField from "@/components/App/Form/gTextField";
import GCol from "@/components/App/Common/GCol";
import GDropDownMenu from "@/components/App/Common/GDropDownMenu";
import GToolbar from "~/components/App/Common/GToolbar.vue";

export default {
  name: "MeasurementResults",
  components: {
    GToolbar,
    GDropDownMenu,
    DccLocalizedTextBlock,
    MeasuringEquipmentList,
    SoftwareList,
    GI18nCard,
    DccResults,
    StatementList,
    InfluenceConditionList,
    UsedMethodList,
    GTextField,
    GCol,
  },
  mixins: [validatableMixin],
  props: {
    value: Object,
    i18n: {
      type: String,
    },
    level: String,
  },
  computed: {
    customRules() {
      return [
        () => {
          return (
            this.value.measurementResult &&
            this.value.measurementResult.length > 0
          );
        },
      ];
    },
  },
  watch: {
    "value.measurementResult"() {
      this.validate();
    },
  },
  methods: {
    availableElements(measurementResult) {
      return [
        "usedMethodListType",
        "measuringEquipmentListType",
        "softwareListType",
        "influenceConditionListType",
        "measurementMetaDataListType",
      ]
        .filter((x) => !this.blacklist(measurementResult).includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.common.${x}.title`),
            value: x,
            addElement: () => this.addElement(x, measurementResult),
          };
        });
    },
    blacklist(measurementResult) {
      return [
        ...insertIf(measurementResult.usedMethods, "usedMethodListType"),
        ...insertIf(
          measurementResult.measuringEquipments,
          "measuringEquipmentListType"
        ),
        ...insertIf(measurementResult.usedSoftware, "softwareListType"),
        ...insertIf(
          measurementResult.influenceConditions,
          "influenceConditionListType"
        ),
        ...insertIf(
          measurementResult.measurementMetaData,
          "measurementMetaDataListType"
        ),
      ];
    },
    addElement(element, measurementResult) {
      switch (element) {
        case "usedMethodListType":
          this.$set(measurementResult, "usedMethods", new UsedMethodListType());
          break;
        case "measuringEquipmentListType":
          this.$set(
            measurementResult,
            "measuringEquipments",
            new MeasuringEquipmentListType()
          );
          break;
        case "softwareListType":
          this.$set(measurementResult, "usedSoftware", new SoftwareListType());
          break;
        case "influenceConditionListType":
          this.$set(
            measurementResult,
            "influenceConditions",
            new InfluenceConditionListType()
          );
          break;
        case "measurementMetaDataListType":
          this.$set(
            measurementResult,
            "measurementMetaData",
            new MeasurementMetaDataListType()
          );
          break;
      }
      this.scrollToElement();
    },
    scrollToElement() {
      this.$nextTick(() => {
        this.$vuetify.goTo(this.$refs.element[this.$refs.element.length - 1]);
      });
    },
    deleteUsedMethods(index) {
      confirm(this.$t("dcc.common.usedMethodListType.confirmRemove")) &&
        this.$delete(this.value.measurementResult[index], "usedMethods");
    },
    deleteMeasuringEquipments(index) {
      confirm(this.$t("dcc.common.measuringEquipmentListType.confirmRemove")) &&
        this.$delete(
          this.value.measurementResult[index],
          "measuringEquipments"
        );
    },
    deleteUsedSoftware(index) {
      confirm(this.$t("dcc.common.softwareListType.confirmRemove")) &&
        this.$delete(this.value.measurementResult[index], "usedSoftware");
    },
    deleteInfluenceConditions(index) {
      confirm(this.$t("dcc.common.influenceConditionListType.confirmRemove")) &&
        this.$delete(
          this.value.measurementResult[index],
          "influenceConditions"
        );
    },
    deleteMeasurementMetaData(index) {
      confirm(
        this.$t("dcc.common.measurementMetaDataListType.confirmRemove")
      ) &&
        this.$delete(
          this.value.measurementResult[index],
          "measurementMetaData"
        );
    },
    addMeasurementResult() {
      this.value.measurementResult.push(new MeasurementResultType());

      // scroll to new element
      this.$nextTick(() => {
        this.$vuetify.goTo(
          this.$refs.measurementResult[this.$refs.measurementResult.length - 1]
        );
      });
    },
    deleteMeasurementResult(measurementResult) {
      confirm(
        this.$t("dcc.measurementResults.measurementResultType.confirmDelete")
      ) && removeFromArray(this.value.measurementResult, measurementResult);
    },
  },
};
</script>
